---
search:
  exclude: true
---
# Dozzle Setup 


Dozzle is a small and lightweight application with a web-based interface to monitor docker logs. It doesn't store any log files. It is for live monitoring of your container logs.

## **Initial Setup**

Dozzle's installation is very simple, i will install it on my current debian VM that i use to run my docker containers:
    
    
    root@docker0:~# docker container ls -a --format "table {{.ID}} \t {{.Names}} \t {{.Size}}"
    CONTAINER ID         NAMES                  SIZE
    e037d2364879         asciinema_nginx        2B (virtual 16.1MB)
    b513c2c6894e         asciinema_phoenix      3.89MB (virtual 97.2MB)
    4dbb7e9c7588         asciinema_smtp         272kB (virtual 210MB)
    a7804b544bee         asciinema_redis        0B (virtual 20.4MB)
    b78623063995         asciinema_postgres     63B (virtual 70.7MB)
    831a57e1a4b6         sharelatex             2.15MB (virtual 3.95GB)
    d9f12a3b40f3         mongo                  14kB (virtual 428MB)
    73817b58274a         redis                  0B (virtual 98.4MB)
    8120b1a3503e         codimd_codimd_1        0B (virtual 820MB)
    cf01b3f17b03         codimd_database_1      63B (virtual 152MB)
    2aca6086627a         neko_neko3_1           162MB (virtual 703MB)
    876c5cf199bf         neko_neko1_1           136MB (virtual 678MB)
    7de701fd022e         neko_neko2_1           80.3MB (virtual 622MB)
    c6a5c7daf4dd         kutt_kutt_1            132kB (virtual 643MB)
    5411baddadcf         kutt_postgres_1        63B (virtual 158MB)
    a685c6747987         kutt_redis_1           0B (virtual 31.2MB)
    f33ae4911086         searx2                 25.1kB (virtual 164MB)
    0ab72043d028         searx                  0B (virtual 164MB)
    	
    

So in order to monitor them, we can use dozzle, let's install it:
    
    
    root@docker0:~# docker pull amir20/dozzle:latest
    latest: Pulling from amir20/dozzle
    70551b8344a5: Pull complete
    bcec85df9694: Pull complete
    Digest: sha256:21d6ea215277b2d5b901d0690aa36af4035a09f51dec07f24e487860ff18ec17
    Status: Downloaded newer image for amir20/dozzle:latest
    root@docker0:~# $ docker run --name dozzle -d --volume=/var/run/docker.sock:/var/run/docker.sock -p 8888:8080 amir20/dozzle:latest
    -bash: $: command not found
    root@docker0:~# docker run --name dozzle -d --volume=/var/run/docker.sock:/var/run/docker.sock -p 8888:8080 amir20/dozzle:latest
    42fae462820311a0e32fd6e829156c36b3de61bd003b04b086ad0a0ba864da76
    	
    

And from here, we have access to our Dozzle instance from port 8888:

![](1.png)

## **Usage**

One of dozzle's great features is the regex / Find feature, to use it just type CTRL+F and type in the pattern you want to match in the logs:

![](2.png)

you can also change the default settings:

![](3.png)

